/* LICENSE START */
/*
 * ssoup
 * https://github.com/alebellu/ssoup
 *
 * Copyright 2012 Alessandro Bellucci
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://alebellu.github.com/licenses/GPL-LICENSE.txt
 * http://alebellu.github.com/licenses/MIT-LICENSE.txt
 */
/* LICENSE END */

/* HEADER START */
var env, requirejs, define;
if (typeof module !== 'undefined' && module.exports) {
    env = "node";
    requirejs = require('requirejs');
    define = requirejs.define;

    requirejs.config({
        baseUrl: __dirname,
        nodeRequire: require
    });

    // require all dependant libraries, so they will be available for the client to request.
    var pjson = require('./package.json');
    for (var library in pjson.dependencies) {
        require(library);
    }
} else {
    env = "browser";
    //requirejs = require;
}

({ define: env === "browser"
        ? define
        : function(A,F) { // nodejs.
            var path = require('path');
            var moduleName = path.basename(__filename, '.js');
            console.log("Loading module " + moduleName);
            module.exports = F.apply(null, A.map(require));
            global.registerUrlContext("/" + moduleName + ".js", {
                "static": __dirname,
                defaultPage: moduleName + ".js"
            });
            global.registerUrlContext("/" + moduleName, {
                "static": __dirname
            });
        }
}).
/* HEADER END */
define(['jquery', 'artusi-kitchen-tools'], function($, tools) {

    var drdf = tools.drdf;
    var drff = tools.drff;

    var underscore = function(context) {
        var pan = this;

        pan.context = context;
    };

    underscore.prototype.init = function(adapter) {
        var dr = $.Deferred();

        this.cookerAdapter = adapter;

        dr.resolve();

        return dr.promise();
    };

    underscore.prototype.start = function() {
        var dr = $.Deferred();

        // Load Underscore JS
        $.getScript("//cdnjs.cloudflare.com/ajax/libs/underscore.js/1.3.3/underscore-min.js").done(drdf(dr)).fail(drff(dr));

        return dr.promise();
    };

    underscore.prototype.stop = function() {};

    underscore.prototype.getContext = function() {};

    underscore.prototype.beforeRecipeCall = function(recipePanParams) {
        var deferreds = [];
        var pan = this;
        var kitchen = pan.context.kitchen;

        // Load templates required by the recipe before its execution, in parallel
        if (recipePanParams["a_:templates"]) {
            $(recipePanParams["a_:templates"]).each(function(index, templateURL) {
                var dr = $.Deferred();
                $.ajax({
                    url: templateURL
                }).done(function(objs) {
                    $('body').append($(objs));
                    dr.resolve();
                }).fail(drff(dr));
                /*kitchen.assistant.getResource({
                    resourceIRI: templateURL,
                    postProcess: "jQuery"
                }).done(function(objs) {
                    $('body').append(objs);
                    dr.resolve();
                }).fail(drff(dr));*/
                deferreds.push(dr);
            });
        }

        // Set as resolved when all templates have been loaded.
        return $.when.apply($, deferreds);
    };

    underscore.prototype.afterServiceCall = function(recipePanParams) {};

    return underscore;
});
